//+------------------------------------------------------------------+
//|                                                  DIV-2-PGrad.mq4 |
//|                                                    Michael H Kim |
//|                                               mhmkim@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Michael H Kim"
#property link      "mhmkim@hotmail.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#include <MovingAverages.mqh>
//--- indicator settings
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Yellow 
//--- input parameter
input int InpDivPeriod=3;
input int MAL=20;
//--- buffers
double ExtDIVBuffer1[];
double MAGradBuff[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(void)
  {
  string short_name;
//--- indicator buffers mapping
   IndicatorBuffers(2);
   IndicatorDigits(Digits);
//---indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtDIVBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MAGradBuff);
//--- name for data window and indicator subwindow label
   short_name="DIV/CON ("+IntegerToString(InpDivPeriod)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//--- check for input parameters
   if(InpDivPeriod<=1)
      {
      Print("Wrong input parameters DIV Period=",InpDivPeriod);
      return(INIT_FAILED);
     }
//---
SetIndexDrawBegin(0,InpDivPeriod);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Divergence                             |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  
   int i,limit;
  
//---
   if(rates_total<=InpDivPeriod || InpDivPeriod<=1)
      return (0);
      
//--- counting from 0 to rates_total
   ArraySetAsSeries(ExtDIVBuffer1, false);
   ArraySetAsSeries(MAGradBuff,false);
   ArraySetAsSeries(open,false);
   ArraySetAsSeries(high,false);
   ArraySetAsSeries(low,false);
   ArraySetAsSeries(close,false);
//--- preliminary calculations
   if(prev_calculated==0)
      {
//--- calculating the first value of the indicator
      limit=InpDivPeriod;
     }
    else
      limit=prev_calculated-1;
      
//--- return value of prev_calculated for next call
    for(i=limit; i<rates_total; i++)
      {
       //ExtDIVBuffer1[i]=(close[i]-close[i-InpDivPeriod])/InpDivPeriod;
       //MAGradBuff[i]=(close[i]-close[i-InpDivPeriod])/InpDivPeriod + .00004;
      // double xB = close[i];
      // double xA = close[i-1];
       
       //MAGradBuff[i] = ((xB - xA)/InpDivPeriod);
       
      MAGradBuff[i]=iMA(NULL,0,MAL,0,MODE_SMA,close[i],i);
      //ExtDIVBuffer1[i]=iMA(NULL,0,MAL,0,MODE_SMA,close[i-InpDivPeriod],i-InpDivPeriod);
      //MAGradBuff[i]=((iMA(NULL,0,20,0,MODE_EMA,close[i],i)-iMA(NULL,0,20,0,MODE_EMA,close[i-InpDivPeriod],i-InpDivPeriod))/InpDivPeriod)*100000;
      
      
      
      //ORIGINAL: MAGradBuff[i]=(iMA(NULL,0,MAL,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,MAL,0,MODE_EMA,PRICE_CLOSE,i-InpDivPeriod))/InpDivPeriod;

     }
//--- reutrn value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
//void OnChartEvent(const int id,
                  //const long &lparam,
                 // const double &dparam,
                //  const string &sparam)
  //{
//---
   
 // }
//+------------------------------------------------------------------+
